<?php
/*
// isdf - inventory system search
// Author: Carsten Schoene
//
// $LastChangedDate: 2013-10-08 11:09:08 +0200 (Tue, 08 Oct 2013) $
// $Rev: 6710 $
*/

// define our name
define('MYNAME', "isdf-client-status");
// open syslog connection
openlog(MYNAME,LOG_PID | LOG_ODELAY,LOG_MAIL);

// check for required extensions
if ( ! extension_loaded("mysql") ) {
        if ( ! dl("mysql") ) {
                syslog(LOG_ERR,"mysql extension not loaded!");
                exit;
        }
}

// load additional files
define('BASE',dirname(__FILE__));
require_once("MDB2.php");
require_once(BASE . "/config.inc.php");
require_once(BASE . "/config-custom.inc.php");
require_once(BASE . "/db.inc.php");

echo '<html><head>
<title>inventory system - client-status</title>
</head>
<body>
';
// create database connection
$dbh =& MDB2::singleton($config['isdf']['db'], $config['mdb2']['options'] );

if ( isset($_POST['delete']) && isset($_POST['inv_system_id'] )) {
	$inv_id = (int)trim($_POST['inv_system_id']);
	if ( is_int($inv_id) ) {
		$inv_id = $dbh->escape($inv_id);

		$delqry = "DELETE FROM inv_system_properties WHERE inv_system_id = '$inv_id'";
		$delres = $dbh->exec($delqry);
		if (PEAR::isError($delres)) {
			syslog(LOG_ERR, "MDB2 delres: " . $delres->getMessage() . "Query was: " .$delqry);
		} else {
			$delqry2 = "DELETE FROM inv_system WHERE id = '$inv_id'";
			$delres2 = $dbh->exec($delqry2);
			if (PEAR::isError($delres2)) {
				syslog(LOG_ERR, "MDB2 delres2: " . $delres->getMessage() . "Query was: " .$delqry2);
			}
		}	
	} else {
		syslog(LOG_ERR, "inv_system_id is set, but not of type INT - Value " . $_POST['inv_system_id'] . " Type " . gettype($_POST['inv_system_id']));
	}
}

$datasql = "SELECT inv_system_id, datakey, value FROM inv_system_properties WHERE (datakey = 'get_system_uuid' OR
		 datakey = 'get_system_default_ip' OR
		 datakey = 'get_system_hostname' OR
		 datakey = 'get_system_software' OR
		 datakey = 'get_system_date') ORDER BY inv_system_id";

$idres = $dbh->query($datasql);
if (PEAR::isError($idres)) {
	syslog(LOG_ERR, "MDB2 idres: " . $idres->getMessage());
} else {
	$data = array();
	while (( $idrow = $idres->fetchRow(MDB2_FETCHMODE_ASSOC) )) {
			if ( $idrow['datakey'] == "get_system_software" ) {
				// extract inventory-system 
				preg_match('/(ix-)?inventory-system-\d+\.\d+\.(rev)?\d+(-\d+\.\d+)?/', $idrow['value'],$treffer);
				$idrow['value'] = $treffer[0];
			} elseif ( $idrow['datakey'] == "get_system_date" ) {
				// convert to unix timestamp
				$idrow['value'] = strtotime($idrow['value']);
			}
			//array_push($data,$idrow);
			$data[$idrow['inv_system_id']]['inv_system_id'] = $idrow['inv_system_id'];
			$data[$idrow['inv_system_id']][$idrow['datakey']] = $idrow['value'];
	}
}
$result = array();
$ver = preg_replace('/-server/','',trim(exec("rpm -qa|grep inventory-system-server")));
$lastlogin = time() - 172800;
echo 'Server Software version: ' . $ver . ' <br/>' . "\n";
echo 'Server allowed last login: ' . $lastlogin . ' (' . date("Y-m-d H:i:s",$lastlogin) . ') <br/>' . "\n";
foreach ( $data as $idx ) {
	if ( $idx['get_system_date'] < $lastlogin ) {
		$idx['last_login_to_old'] = 1;
		array_push($result, $idx);
		continue;
	} elseif ( trim($idx['get_system_software']) < $ver ) {
		$idx['software_to_old'] = 1;
		array_push($result, $idx);
		continue;
	}
}
foreach ($result as $mkey) {
	echo '<form method="POST" name="deleteform" action="' . $_SERVER['PHP_SELF'] . '">';
	echo '<table><tr><th>Key:</th><th>Value:</th><th>Action:</th></tr>' . "\n";
	foreach ( $mkey as $key => $value ) {
		if ( $key == "inv_system_id" ) {
			echo '<tr><td>' . $key . '</td><td>' . $value . '</td><td><input type="hidden" name="inv_system_id" value="' . $value . '"><input type="submit" name="delete" value="Delete from DB"></td></tr>' . "\n";
		} elseif ( $key == "get_system_date" ) {
			echo '<tr><td>' . $key . '</td><td>' . $value . " / " . date("Y-m-d H:i:s",$value) . '</td><td>&nbsp;</td></tr>' . "\n";
		} else {
        		echo '<tr><td>' . $key . '</td><td>' . $value . '</td><td>&nbsp;</td></tr>' . "\n";
		}
	}
	echo '</table><hr/>' . "\n";
	echo '</form>'. "\n";
}
echo '</body></html>' . "\n";
$dbh->disconnect();
?>
