<?php
// $LastChangedDate: 2012-09-18 14:47:51 +0200 (Tue, 18 Sep 2012) $
// $Rev: 1855 $

class dhcpconf {
	var $dhcpdHosts;
	var $hosts;
	var $iterator;
	
	public function __construct($filename){
		$this->iterator = -1;
		$this->dhcpdHosts = $filename;
	}
	
	public function addHost($name, $mac, $ip){
		if(! $fh = fopen($this->dhcpdHosts, 'a')){
			print("ERROR: ");
			print(" Unable to open $this->dhcpdHosts for writing!\n");
			exit;
		}
		
		$line = "host $name {\n\thardware ethernet $mac;\n\tfixed-address $ip;\n}\n";
		fwrite($fh, $line);
		fclose($fh);
	}
	
	public function removeHost($mac){
		if(! $fh = fopen($this->dhcpdHosts, 'r')){
			print("ERROR: ");
			print(" Unable to open '$this->dhcpdHosts' for reading/writing!\n");
			exit;
		}
		
		$found = false;
		
		while(!feof($fh))
			$file[] = fgets($fh, 1024);
		
		for($i = 0; $i < sizeof($file); $i++){
			if(isset($j) && $j < sizeof($file)){
				$file[$i] = $file[$j];
				$j++;
				continue;
			}
			if(isset( $j ) && ( $j >= sizeof($file)) ){
				unset($file[$i]);
				$j++;
				continue;
			}
					
			if(preg_match("/\#? host\s+ (?i)[a-z -]+ \s* \{/x", $file[$i])){
				if(preg_match("/\#? \s+hardware\sethernet\s" . $mac . "\;/x", $file[$i+1])){
					$found = true;
					$j = $i + 4;
					$file[$i] = $file[$j];
					$j++;
				}  // End of Mac match
			} // End of host entry
		} // End of for loop


		if($found){
			fclose($fh);
			$fh = fopen($this->dhcpdHosts, 'w');
			for($i = 0; $i < sizeof($file); $i++){
				if ( isset($file[$i])) {
					fwrite($fh, $file[$i]);
				}
			}  // End of writing
		}
		
		fclose($fh);
		return $found;
	}
	
	public function readHosts(){
		
		if(! $fh = fopen($this->dhcpdHosts, 'r')){
			print("ERROR: ");
			print(" Unable to open '$this->dhcpdHosts' for reading!\n");
			exit;
		}
		
		while(!feof($fh)){
			$line = fgets($fh, 1024);
			
			if(preg_match("/^(\}|\#\})/", $line))
			{
				$this->hosts[] = $this->parseHost($entry);
				unset($entry);
				continue;
			}
			
			$entry[] = $line;
		}
		
		fclose($fh);
		return;
	}
	
	private function parseHost($entry){
		list(,$name) = explode(" ", $entry[0]);
		list(,,$mac) = explode(" ", $entry[1]);
		
		if(preg_match("/^(\#)/", $entry[0]))
			$status = "disabled";
		else 
			$status = "enabled";
		
		return array("hostname" => $name, "mac" => substr($mac, 0, -2), "status" => $status);
	}
	
	public function nextHost(){
		if($this->iterator >= sizeof($this->hosts) )
			return false;
		else
			return $this->hosts[++$this->iterator];
	}
	
	public function rewindHosts(){
		$this->iterator = -1;
	}
	
	public function disableHost($mac){
		if(! $fh = fopen($this->dhcpdHosts, 'r')){
			print("ERROR: ");
			print(" Unable to open '$this->dhcpdHosts' for reading/writing!\n");
			exit;
		}
		
		$found = false;
		
		while(!feof($fh))
			$file[] = fgets($fh, 1024);
		
		for($i = 0; $i < sizeof($file); $i++){	
			if(preg_match("/^host\s+(?i)[a-z -]+\s*\{/", $file[$i])){
				if(preg_match("/\s+hardware\sethernet\s" . $mac . "\;/", $file[$i+1])){
					$found = true;
					for($j = 0; $j < 4; $j++)
						$file[$i + $j] = "#" . $file[$i + $j];
				}  // End of Mac match
			} // End of host entry line
		} // End of for loop


		if($found){
			fclose($fh);
			$fh = fopen($this->dhcpdHosts, 'w');
			for($i = 0; $i < sizeof($file); $i++){
				fwrite($fh, $file[$i]);
			}  // End of writing
		}
		
		fclose($fh);
		return $found;
	}
	
	/**
	* @return bool
	* @param string $mac
	* @desc Enables host entry by uncommenting it in the host file if the mac address exists and is commented.
	*/
	public function enableHost($mac){
		if(! $fh = fopen($this->dhcpdHosts, 'r')){
			print("ERROR: ");
			print(" Unable to open '$this->dhcpdHosts' for reading/writing!\n");
			exit;
		}
		
		$found = false;
		
		while(!feof($fh))
			$file[] = fgets($fh, 1024);
		
		for($i = 0; $i < sizeof($file); $i++){	
			if(preg_match("/^\#host\s+(?i)[a-z -]+\s*\{/", $file[$i])){
				if(preg_match("/\#\s+hardware\sethernet\s" . $mac . "\;/", $file[$i+1])){
					$found = true;
					for($j = 0; $j < 4; $j++)
						$file[$i + $j] = substr($file[$i + $j], strpos($file[$i+$j], "#") + 1);
				}  // End of Mac match
			} // End of host entry line
		} // End of for loop


		if($found){
			fclose($fh);
			$fh = fopen($this->dhcpdHosts, 'w');
			for($i = 0; $i < sizeof($file); $i++){
				fwrite($fh, $file[$i]);
			}  // End of writing
		}
		
		fclose($fh);
		return $found;
	}
	
	public function hostExists($hostname, $mac, $reread = true ){
		if ( $reread == true ) {
			$this->readHosts();
		}
		$match = false;
		if ( isset($this->hosts) ) {
			foreach($this->hosts as $host){
				/*
				if(strtoupper($hostname) == strtoupper($host["hostname"])){
					$match = 1;
				}
				elseif(strtoupper($mac) == strtoupper($host["mac"])){
					$match = 2;
				}
				*/
				if ( $hostname == $host["hostname"] ) {
					$match = 1;
				}
				elseif ( $mac == $host["mac"] ) {
					$match = 2;
				}
				if($match)
					break;
			}
		
			return $match;
		} else {
			return false;
		}
	}
		
}

?>
