<?php
// $LastChangedDate: 2012-09-14 10:19:04 +0200 (Fri, 14 Sep 2012) $
// $Rev: 1792 $

class inv_dhcp4 {
	function mac_is_valid($mac)
	{
		$mac = strtolower(trim($mac));
		if ( preg_match('/[0-9a-f]{2}:[0-9a-f]{2}:[0-9a-f]{2}:[0-9a-f]{2}:[0-9a-f]{2}:[0-9a-f]{2}/', $mac) )
		{
			return true;
		} else {
			return false;
		}
	}

	function mac_is_blacklisted($mac)
	{
		global $config;
		$mac = strtolower(trim($mac));
		if ( $mac == "none" )
		{
			return false;
		}
		elseif ( $this->mac_is_valid($mac) )
		{
			if ( array_search($mac, $config["isdf"]["dhcp"]["macblacklist"]) === false )
			{
				return false;
			} else {
				return true;
			}
		} else {
			return false;
		}
	}

	function int_is_blacklisted($int)
	{
		global $config;
		$int = strtolower(trim($int));
		if ( $int == "none" )
		{
			return false;
		}
		elseif( $int == "" )
		{
			return false;
		} else {
			if ( array_search($int, $config["isdf"]["dhcp"]["intblacklist"]) === false )
			{
				return false;
			} else {
				return true;
			}
		}
	}

	function int_is_valid($mac,$int,$link)
	{
		if ( $link == "yes" ) {
			if ( $this->mac_is_valid($mac)) {
				if ( $this->mac_is_blacklisted($mac)) {
					return false;
				} elseif ( $this->int_is_blacklisted($int)) {
					return false;
				} else {
					return true;
				}
			} else {
				return false;
			}
		} else {
			return false;
		}
	}	
}

?>
