<?php
/*
// isdf - inventory system deployment feed
// Author: Carsten Schoene
//
// $LastChangedDate: 2012-09-10 17:22:56 +0200 (Mon, 10 Sep 2012) $
// $Rev: 1760 $
*/

// define our name
define('MYNAME', "isdf");
// open syslog connection
openlog(MYNAME,LOG_PID | LOG_ODELAY,LOG_MAIL);

// check for required extensions
if ( ! extension_loaded("mysql") ) {
        if ( ! dl("mysql") ) {
                syslog(LOG_ERR,"mysql extension not loaded!");
                exit;
        }
}

// load additional files
define('BASE',dirname(__FILE__));
require_once("MDB2.php");
require_once(BASE . "/config.inc.php");
require_once(BASE . "/config-custom.inc.php");
require_once(BASE . "/db.inc.php");

// initialize variables
$request_complete=1;
$data=array();

// function valid_uuid
function valid_uuid ( $uuid ) {
	$uuid = trim($uuid);
	$regex = '/[A-F0-9]{8}-[A-F0-9]{4}-[A-F0-9]{4}-[A-F0-9]{4}-[A-F0-9]{12}/';
	if ( strlen($uuid) == 36  &&  preg_match($regex,$uuid) ) {
		return true;
	} else {
		return false;
	}
}

function run_insert_tasks($systemid, $key, $value) {

}

function run_update_tasks($systemid, $key, $value) {

}

// check if all post fields are set and save them to data array
if ( isset($_POST) ) {
	foreach ( $config["isdf"]["postvars"] as $POSTVAR ) {
		if ( isset($_POST[$POSTVAR]) ) {
			$value = urldecode($_POST[$POSTVAR]);
			$data[$POSTVAR] = $value;
			syslog(LOG_INFO, $POSTVAR . ": ". $value);
		} else {
			$request_complete=0;
		}			
	}

	// for custom postvars
	foreach ( $config["isdf"]["custom_postvars"] as $POSTVAR ) {
		if ( isset($_POST[$POSTVAR]) ) {
			$value = urldecode($_POST[$POSTVAR]);
			$data[$POSTVAR] = $value;
			syslog(LOG_INFO, $POSTVAR . ": ". $value);
		}
	}
}

// last check before connecting to database
if (!isset($data['get_system_uuid']) ) {
        syslog(LOG_ERR,"DATA: get_system_uuid not found");
        die();
}

// create database connection
$dbh =& MDB2::singleton($config['isdf']['db'], $config['mdb2']['options'] );

$uuidkey = $data['get_system_uuid'];


if ( valid_uuid($uuidkey) ) {
	// check for existing uuid entry
	$uuidchecksql = "SELECT id FROM inv_system WHERE system_uuid = '$uuidkey'";
	$res = $dbh->query($uuidchecksql);
	if (PEAR::isError($res)) {
		syslog(LOG_ERR, "MDB2: " . $res->getMessage());
	} elseif ( $res->numRows() == 1 ) {
		// uuid already exists, just update data for this host
		$row = $res->fetchRow(MDB2_FETCHMODE_ASSOC);
		$systemid = $row['id'];

		foreach ( $data as $key => $value ) {
			// check if systemid/key pair exists
			$sysidkeysql = "SELECT inv_system_id, datakey FROM inv_system_properties WHERE inv_system_id='$systemid' AND datakey='$key'";
			$sysidkeyres = $dbh->query($sysidkeysql);
			
			if (PEAR::isError($sysidkeyres)) {
				syslog(LOG_ERR, "MDB2: " . $sysidkeyres->getMessage());
			} elseif ( $sysidkeyres->numRows() == 1 ) {
				// define update query
				$updatesql = "UPDATE inv_system_properties SET value='$value' WHERE inv_system_id='$systemid' AND datakey='$key'";
				$updres = $dbh->exec($updatesql);
				if (PEAR::isError($updres) ){
					syslog(LOG_ERR,"MDB2: UPDATE of inv_system_properties failed with " . $updres->getMessage());
				} else {
					run_update_tasks($systemid, $key, $value);
				}

			} elseif ( $sysidkeyres->numRows() == 0 ) {		
				// if systemid / key pair does not exist, create it - happens on feature update
				$insertsql = "INSERT INTO inv_system_properties (inv_system_id,datakey,value) VALUES ('$systemid','$key','$value')";
				$insres = $dbh->exec($insertsql);
				if (PEAR::isError($insres) ){
                                        syslog(LOG_ERR,"MDB2: INSERT into inv_system_properties failed with " . $insres->getMessage());
				} else {
					run_insert_tasks($systemid, $key, $value);
				}
			} else {
				// this should never happen, but in case log the numRows result
				syslog(LOG_ERR,"MDB2: systemid/key pair query resulted in unsupported result " . $sysidkeyres->numRows());
			}
			
		}
	} elseif ( $res->numRows() == 0 ) {
		// uuid does not exist, insert uuid and data
		$newinssql = "INSERT INTO inv_system (system_uuid) VALUES ('$uuidkey')";
		$newinsres = $dbh->exec($newinssql);
		if (PEAR::isError($newinsres) ) {
			syslog(LOG_ERR,"MDB2: INSERT into inv_system failed with " . $newinsres->getMessage());
		} else {
			$systemid = $dbh->lastInsertId('inv_system', 'id');
			syslog(LOG_INFO, "MDB2: INSERT into inv_system successfull with id " . $systemid);

			foreach ( $data as $key => $value ) {
				// check if systemid/key pair exists
				$sysidkeysql = "SELECT inv_system_id, datakey FROM inv_system_properties WHERE inv_system_id='$systemid' AND datakey='$key'";
				$sysidkeyres = $dbh->query($sysidkeysql);
				if (PEAR::isError($sysidkeyres)) {
					syslog(LOG_ERR, "MDB2: " . $sysidkeyres->getMessage());
				} elseif ( $sysidkeyres->numRows() == 1 ) {
					// define update query
					$updatesql = "UPDATE inv_system_properties SET value='$value' WHERE inv_system_id='$systemid' AND datakey='$key'";
					$updres = $dbh->exec($updatesql);
					if (PEAR::isError($updres) ){
						syslog(LOG_ERR,"MDB2: UPDATE of inv_system_properties failed with " . $updres->getMessage());
					} else {
						run_update_tasks($systemid, $key, $value);
					}
				} elseif ( $sysidkeyres->numRows() == 0 ) {
					// if systemid / key pair does not exist, create it - happens on feature update
					$insertsql = "INSERT INTO inv_system_properties (inv_system_id,datakey,value) VALUES ('$systemid','$key','$value')";
					$insres = $dbh->exec($insertsql);
					if (PEAR::isError($insres) ){
						syslog(LOG_ERR,"MDB2: INSERT into inv_system_properties failed with " . $insres->getMessage());
					} else {
						run_insert_tasks($systemid, $key, $value);
					}
				} else {
					// this should never happen, but in case log the numRows result
					syslog(LOG_ERR,"MDB2: systemid/key pair query resulted in unsupported result " . $sysidkeyres->numRows());
				}

			}
		}
	} else {
		// this should never happen, but in case log the numRows result
		syslog(LOG_ERR, "MDB2: uuid query resulted in unsupported result " . $res->numRows());
	}		
} else {
	syslog(LOG_ERR, "Invalid uuid found: " . $uuidkey);
}
// close database connection
$dbh->disconnect();

// close syslog connection
closelog();
?>
